#include <windows.h>
#include <stdio.h>
#include <GL/glut.h>

#include "render.h"


static camera cam;

// Selection Buffer
#define SelBufferSize 512


static int mainWindow;
static int border = 6,h=200,w=350;


// Picking Stuff //
#define RENDER					1
#define SELECT					2
#define BUFSIZE 1024
GLuint selectBuf[BUFSIZE];
GLint hits;
int mode = RENDER;
int cursorX,cursorY;


//----------------------
// Resizing
//----------------------



void changeSize(int w1, int h1) {

	float ratio;

	h = h1;
	w = w1;
	// Prevent a divide by zero, when window is too short
	// (you cant make a window of zero width).

	if(h == 0)
		h = 1;

	ratio = 1.0f * w / h;
	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	// Set the viewport to be the entire window
    glViewport(0, 0, w, h);

	// Set the clipping volume
	gluPerspective(45,ratio,0.1,1000);

	// setting the camera now
	glMatrixMode(GL_MODELVIEW);
}


//---------------
// Picking Stuff
//---------------



void processPick ()
{
	GLint viewport[4];
	GLubyte pixel[3];

	glGetIntegerv(GL_VIEWPORT,viewport);

	glReadPixels(cursorX,viewport[3]-cursorY,1,1,GL_RGB,GL_UNSIGNED_BYTE,(void *)pixel);

	printf("%d %d %d\n",pixel[0],pixel[1],pixel[2]);
	if (pixel[0] == 255)
	  printf ("You picked the 1st snowman on the 1st row");
	else if (pixel[1] == 255)
	  printf ("You picked the 1st snowman on the 2nd row");
	else if (pixel[2] == 255)
	  printf ("You picked the 2nd snowman on the 1st row");
	else if (pixel[0] == 250)
	  printf ("You picked the 2nd snowman on the 2nd row");
   else
	   printf("You didn't click a snowman!");
  printf ("\n");
   
}




//-----------------
// Rendering
//-----------------




void renderScene() {


	glutSetWindow(mainWindow);  

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glLoadIdentity();


	gluLookAt(cam.pos[0],
		      cam.pos[1],
			  cam.pos[2],   

			  cam.lookAt[0],
			  cam.lookAt[1],
			  cam.lookAt[2],    

			  cam.lookUp[0],
			  cam.lookUp[1],
			  cam.lookUp[2]);


	if (mode == SELECT)
		drawPickingMode();
	else
		draw();

	if (mode == SELECT) {
		processPick();
		mode = RENDER;
	}
	else
		glutSwapBuffers();
}



//-------------------
// Keyboard and Mouse
//-------------------


void processNormalKeys(unsigned char key, int x, int y) {

	if (key == 27) {
		quit();
	}
	else
		processKeyboard(key, x, y);
}




void mouseStuff(int button, int state, int x, int y) {



	if (button != GLUT_LEFT_BUTTON || state != GLUT_DOWN)
		return;

	cursorX = x;
	cursorY = y;
	mode = SELECT;
}





//---------
// Main
//---------

int main(int argc, char **argv)
{

	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DEPTH  | GLUT_DOUBLE | GLUT_RGBA);
	glutInitWindowPosition(100,100);
	glutInitWindowSize(w,h);
	mainWindow = glutCreateWindow("SnowMen from Lighthouse 3D");

	glutKeyboardFunc(processNormalKeys);
	glutReshapeFunc(changeSize);
	glutDisplayFunc(renderScene);
	glutMouseFunc(mouseStuff);
	glutIdleFunc(renderScene);


	initScene(argc,argv);
	init(&cam);

	glutMainLoop();

	return(0);
}
