#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>

// convert screen coordinates -> world coordinates
void convertSCSToWCS(int x, int y, float& wx, float& wy)
{
	float worldsizex = 4.0;	// gluOrtho2D (-2.0, 2.0, -2.0, 2.0);
	float worldsizey = 4.0;	// gluOrtho2D (-2.0, 2.0, -2.0, 2.0);
	float screensizex = (float) glutGet(GLUT_WINDOW_WIDTH);
	float screensizey = (float) glutGet(GLUT_WINDOW_HEIGHT);

	// glut mouse coordinates -> world coordinates
    //wx = (worldsizex * (float)x / screensizex) - (worldsizex / 2);
    //wy = (worldsizey / 2) - (worldsizey * (float)y / screensizey);

	wx = (worldsizex * (float)x / screensizex) - (worldsizex / 2);
    wy = (worldsizey * (float)y / screensizey) - (worldsizey / 2);
}

int pick(int x, int y)
{
	float wx, wy;
	y = glutGet(GLUT_WINDOW_HEIGHT) - y;	// convert glut mouse coordinates -> gl screen coordinates
	convertSCSToWCS(x, y, wx, wy);			// convert gl screen coordinates -> gl world coordinates
	if ((wx > 0.5) && (wx < 1.5) && (wy > -1.2) && (wy < -0.2))			// green
		return 2;
	else if ((wx > -1.5) && (wx < 0.0) && (wy > -0.5) && (wy < 1.5))	// red
		return 3;
	else if ((wx > -0.7) && (wx < 1.0) && (wy > -0.7) && (wy < 1.0))	// blue
		return 1;
	else
		return 0;
}

void init()
{
   glClearColor (0.0, 0.0, 0.0, 0.0);
}

void drawObjects()
{
    glColor3f(0.0, 0.0, 1.0);	// blue
    glRectf(-0.7, -0.7, 1.0, 1.0);

	glColor3f(0.0, 1.0, 0.0); // green
    glRectf(0.5, -1.2, 1.5, -0.2);

	glColor3f(1.0, 0.0, 0.0);	// red
	glBegin(GL_TRIANGLES);
	glVertex2f(-1.5, -0.5);
	glVertex2f(0.0, 0.0);
	glVertex2f(-1.0, 1.5);
	glEnd();
}

void display()
{
    glClear(GL_COLOR_BUFFER_BIT);
    drawObjects();
    glFlush();
}

void mouse(int button, int state, int x, int y)
{
   int where = 0;

   if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
   {
	   //glPushAttrib(GL_ALL_ATTRIB_BITS);
	   where = pick(x, y);
	   if (where == 1)
		   fprintf(stderr, "pick blue\n");
	   else if (where == 2)
		   fprintf(stderr, "pick green\n");
	   else if (where == 3)
		   fprintf(stderr, "pick red\n");
	   else
		   fprintf(stderr, "pick none\n");
	   //glPopAttrib();
	   glutPostRedisplay();
   }
}

void reshape(int w, int h)
{
   glViewport(0, 0, w, h);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D (-2.0, 2.0, -2.0, 2.0);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
}

void keyboard(unsigned char key,int x, int y)
{
   switch (key)
   {
      case 27:
         exit(0);
         break;
   }
}

/* main loop */ 
int main(int argc, char** argv)
{
   glutInit(&argc, argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
   glutInitWindowSize (500, 500);
   glutInitWindowPosition (100, 100);
   glutCreateWindow (argv[0]);
   init ();
   glutReshapeFunc (reshape);
   glutDisplayFunc(display);
   glutMouseFunc (mouse);
   glutKeyboardFunc (keyboard);
   glutMainLoop();
   return 0;
}
