#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>

void init()
{
   glClearColor (0.0, 0.0, 0.0, 0.0);
}

void drawObjects()
{
    glColor3f(0.0, 0.0, 1.0);	// blue
    glRectf(-0.7, -0.7, 1.0, 1.0);

	glColor3f(0.0, 1.0, 0.0); // green
    glRectf(0.5, -1.2, 1.5, -0.2);

	glColor3f(1.0, 0.0, 0.0);	// red
	glBegin(GL_TRIANGLES);
	glVertex2f(-1.5, -0.5);
	glVertex2f(0.0, 0.0);
	glVertex2f(-1.0, 1.5);
	glEnd();
}

void drawPickingMode()
{
	glDisable(GL_DITHER);
 	glPushMatrix();
		
	// A different color for each polygon
    glColor3ub(0,0,255);	// blue
    glRectf(-0.7, -0.7, 1.0, 1.0);

	glColor3ub(0,255,0);	// green
    glRectf(0.5, -1.2, 1.5, -0.2);

	glColor3ub(255,0,0);	// red
	glBegin(GL_TRIANGLES);
	glVertex2f(-1.5, -0.5);
	glVertex2f(0.0, 0.0);
	glVertex2f(-1.0, 1.5);
	glEnd();

	glPopMatrix();
	glEnable(GL_DITHER);
}



int pick(int x, int y)
{
	GLint viewport[4];
	GLubyte pixel[3];

	glGetIntegerv(GL_VIEWPORT, viewport);
	drawPickingMode();

	glReadPixels(x, viewport[3] - y, 1, 1, GL_RGB, GL_UNSIGNED_BYTE, (void *)pixel);
	printf("RGB %u %u %u\n", (unsigned int)pixel[0], (unsigned int)pixel[1], (unsigned int)pixel[2]);

	if ((unsigned int)pixel[2] == 255)	// blue
		return 1;
	else if ((unsigned int)pixel[1] == 255)	// green
		return 2;
	else if ((unsigned int)pixel[0] == 255)		// red
		return 3;
	else
		return 0;
}

void display()
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

	drawObjects();
	glutSwapBuffers();
}

void mouse(int button, int state, int x, int y)
{
	if (button == GLUT_LEFT_BUTTON && state == GLUT_UP) {
		int where = pick(x, y);
		if (where == 1)
		   fprintf(stderr, "pick blue\n");
	    else if (where == 2)
		   fprintf(stderr, "pick green\n");
	    else if (where == 3)
		   fprintf(stderr, "pick red\n");
	    else
		   fprintf(stderr, "pick none\n");
	}
}

void reshape(int w, int h)
{
   glViewport(0, 0, w, h);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D (-2.0, 2.0, -2.0, 2.0);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
}

void keyboard(unsigned char key,int x, int y)
{
   switch (key)
   {
      case 27:
         exit(0);
         break;
   }
}

/* main loop */ 
int main(int argc, char** argv)
{
   glutInit(&argc, argv);
   glutInitDisplayMode (GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
   glutInitWindowSize (500, 500);
   glutInitWindowPosition (100, 100);
   glutCreateWindow (argv[0]);
   init ();
   glutReshapeFunc (reshape);
   glutDisplayFunc(display);
   glutMouseFunc (mouse);
   glutKeyboardFunc (keyboard);
   glutMainLoop();
   return 0;
}
